// CalendarHelp install in Mozilla Suite
const BUILD_VERSION = "0.5";
const BUILD_LOCALE = "en-US"";
const RESTART_MSG = "To complete the installation, restart the program";
const FAILED_MSG = "Installation failed";
const DISPLAY_NAME = "Calendar Help";

const projectname = "calendarhelp";
const name        = "CalendarHelp";

var jarfile = projectname + "-" + BUILD_LOCALE + ".jar";

var failed = false, rc;
try {
	preinstall();
	register();
	install();
	}
catch (e) {
	failed = true;
	alert(FAILED_MSG + "\n" + e );
	cancelInstall(rc);
	}
finally {
	if (!failed) alert (RESTART_MSG);
	}
	

function preinstall() {
	rc = initInstall(DISPLAY_NAME, name, BUILD_VERSION);
	if (rc == SUCCESS)
		logComment("initInstall OK");
	else {
		logComment("initInstall error " + rc);
		throw "preinstall error " + rc;
		}

	myDir = getFolder("Chrome", projectname);
	logComment("directory: " + myDir);
	setPackageFolder(myDir);

	rc = addFile(name + "Chrome", "chrome/" + jarfile, getFolder("Chrome"), "");
	if (rc == SUCCESS)
		logComment("addFile chrome/" + jarfile + " OK");
	else {
		logComment("addFile chrome/" + jarfile + " error " + rc);
		throw "preinstall error " + rc;
		}
	}


function register() {
	var source = getFolder("Chrome", jarfile);
	
	registerChrome(
		PACKAGE | DELAYED_CHROME,
		source,
		"content/" + projectname + "/");

	registerChrome(
		SKIN | DELAYED_CHROME,
		source,
		"skin/classic/" + projectname + "/");

	registerChrome(
		LOCALE | DELAYED_CHROME,
		source,
		"locale/" + BUILD_LOCALE + "/" + projectname + "/");

	rc = getLastError();
	if (rc != SUCCESS) {
		logComment("registerChrome error " + rc);
		throw "register error " + rc;
		}
	}


function install() {
	rc = performInstall();
	if (rc != SUCCESS && rc != REBOOT_NEEDED) {
		logComment("performInstall error " + rc);
		throw "install error " + rc;
		}
	}
